<template>
  <div>
    <h1>Productos</h1>
    <!------FORMULARIO PARA REGISTRAR UN PRODUCTO----->
    <div>
      <!-----Fila para el nombre y precio del producto-->
      <div class="row">
        <!--Nombre-->
        <div class="col-6 mb-3">
          <input
            type="text"
            class="form-control"
            id="nombre"
            placeholder="Nombre producto"
            v-model="nombre"
          />
        </div>
        <!--Precio-->
        <div class="col-6 mb-3">
          <input
            type="number"
            class="form-control"
            id="precio"
            placeholder="Precio producto"
            v-model="precio"
          />
        </div>
      </div>
      <!-------Fila para categoría y descripción---->
      <div class="row">
        <!--Categorias-->
        <div class="col-6 mb-3">
          <select
            v-model="categoria"
            class="form-select"
            aria-label="Default select example"
          >
            <option selected value="null">Categoría</option>
            <option value="Bebidas">Bebidas</option>
            <option value="Licores">Licores</option>
            <option value="Frutas">Frutas</option>
          </select>
        </div>
        <!--Descripción-->
        <div class="col-6 mb-3">
          <input
            type="text"
            class="form-control"
            id="descripcion"
            placeholder="Descripción producto"
            v-model="descripcion"
          />
        </div>
      </div>
      <!-----Fila pra la url de la imagen---->
      <div class="row">
        <!--Url imagen-->
        <div class="col-12 mb-3">
          <input
            type="text"
            class="form-control"
            id="urlImagen"
            placeholder="Aquí url de la imagen"
            v-model="urlImagen"
          />
        </div>
      </div>
      <!-----Botón de registro--->
      <button v-if="id == null" type="button" class="btn btn-success" @click="btnRegistrar">Registrar</button>
      &nbsp;
      <!----Botón cancelar---->
      <button v-if="id != null" type="button" class="btn btn-secondary" @click="limpiarCampos">Cancelar</button>
      &nbsp;
      <!---botón de actualizar---->
      <button v-if="id != null" type="button" class="btn btn-warning" @click="btnActualizar">Actualizar</button>
    </div>
    <!-----TABLA DE PRODUCTOS----->
    <table class="table table-striped table-hover">
      <!---Cabecera de la tabla---->
      <thead>
        <tr>
          <th scope="col">Imagen</th>
          <th scope="col">Nombre</th>
          <th scope="col">Precio</th>
          <th scope="col">Categoria</th>
          <th scope="col">Descripción</th>
          <th scope="col">Acciones</th>
        </tr>
      </thead>
      <!---Cuerpo de la tabla---->
      <tbody>
        <tr v-for="objProducto in productos" :key="objProducto._id">
          <!---Imagen--->
          <td>
              <img :src="objProducto.urlImagen" class="avatar img-thumbnail rounded mx-auto d-block" :alt="objProducto.nombre">
          </td>
          <!---Nombre--->
          <td>{{ objProducto.nombre }}</td>
          <!---Precio--->
          <td>{{ objProducto.precio }}</td>
          <!---Categoria--->
          <td>{{ objProducto.categoria }}</td>
          <!---Descripción--->
          <td>{{ objProducto.descripcion }}</td>
          <!----Acciones--->
          <td>
            <!----Editar--->
            <button type="button" class="btn btn-primary" @click="btnEditar(objProducto)">Editar</button>
            &nbsp;
            <!----Eliminar--->
            <button type="button" class="btn btn-danger" @click="btnEliminar(objProducto._id)">Eliminar</button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import store from "../store/index.js";

export default {
  data: () => {
    return {
      nombre: null,
      precio: null,
      categoria: null,
      descripcion: null,
      urlImagen: null,
      id: null
    };
  },
  methods: {
    btnRegistrar() {
      if (
        this.nombre != null &&
        this.precio != null &&
        this.categoria != null &&
        this.descripcion != null &&
        this.urlImagen != null
      ) {
          //Crear un objeto del producto con los datos del formulario
          let objProducto = {
              nombre: this.nombre,
              precio: this.precio,
              categoria: this.categoria,
              descripcion: this.descripcion,
              urlImagen: this.urlImagen
          }
          //Llamar la acción del store y enviar el objeto
          store.dispatch('crearProducto', objProducto).then(()=>{
              this.limpiarCampos();
              store.dispatch("cargarProductos");
          });
      }
    },
    limpiarCampos(){
        this.nombre = null;
        this.precio = null;
        this.categoria = null;
        this.descripcion = null;
        this.urlImagen = null;
        this.id = null;
    },
    //Método para eliminar un producto
    btnEliminar(id){
        let obj = {
            id: id
        }
        store.dispatch('eliminarProducto', obj).then(()=>{
            store.dispatch("cargarProductos");
        });
    },
    btnEditar(objProducto){
        this.nombre = objProducto.nombre;
        this.precio = objProducto.precio;
        this.categoria = objProducto.categoria;
        this.descripcion = objProducto.descripcion;
        this.urlImagen = objProducto.urlImagen;
        this.id = objProducto._id;
    },
    btnActualizar(){
        let objProducto = {
            id: this.id,
            nombre: this.nombre,
            precio: this.precio,
            categoria: this.categoria,
            descripcion: this.descripcion,
            urlImagen: this.urlImagen
        }
        //Llamar las acciones del store
        store.dispatch('actualizarProducto', objProducto).then(()=>{
            this.limpiarCampos();
            store.dispatch("cargarProductos");
        });
    }
  },
  created: () => {
    //Llamar las acciones del store
    store.dispatch("cargarProductos");
  },
  computed: {
    productos: () => {
      return store.state.productos;
    },
  },
};
</script>

<style>
.avatar{
    height: 80px;
    width: 80px;
}
</style>